#-----------------------------------------------------------------------------
#
# TEEMConfig.cmake - TEEM CMake configuration file for external projects.
#
# This file is configured by TEEM and used by the UseTEEM.cmake module
# to load TEEM's settings for an external project.

# Compute the installation prefix from TEEM_DIR.
SET(TEEM_INSTALL_PREFIX "${TEEM_DIR}")
GET_FILENAME_COMPONENT(TEEM_INSTALL_PREFIX "${TEEM_INSTALL_PREFIX}" PATH)
GET_FILENAME_COMPONENT(TEEM_INSTALL_PREFIX "${TEEM_INSTALL_PREFIX}" PATH)

# The TEEM source tree.
SET(TEEM_SOURCE_DIR "")

# The TEEM include file directories.
SET(TEEM_EXECUTABLE_DIRS "${TEEM_INSTALL_PREFIX}/bin")
SET(TEEM_LIBRARY_DIRS "${TEEM_INSTALL_PREFIX}/lib/TEEM-1.9")
SET(TEEM_LIBRARIES "air;hest;biff;nrrd;ell;unrrdu;dye;moss;gage;bane;limn;hoover;alan;echo;ten;mite;coil;push")
SET(TEEM_INCLUDE_DIRS "${TEEM_INSTALL_PREFIX}/include/teem")

# The C flags added by TEEM to the cmake-configured flags.
SET(TEEM_REQUIRED_C_FLAGS "")

# The TEEM version number
SET(TEEM_VERSION_MAJOR "1")
SET(TEEM_VERSION_MINOR "9")
SET(TEEM_VERSION_PATCH "0")

# Is TEEM using shared libraries?
SET(TEEM_BUILD_SHARED_LIBS "ON")
SET(TEEM_BUILD_SETTINGS_FILE "${TEEM_INSTALL_PREFIX}/lib/TEEM-1.9/TEEMBuildSettings.cmake")

# The location of the UseTEEM.cmake file.
SET(TEEM_USE_FILE "${TEEM_INSTALL_PREFIX}/lib/TEEM-1.9/TEEMUse.cmake")

# The ExodusII library dependencies.
IF(NOT TEEM_NO_LIBRARY_DEPENDS)
  INCLUDE("${TEEM_INSTALL_PREFIX}/lib/TEEM-1.9/TEEMLibraryDepends.cmake")
ENDIF(NOT TEEM_NO_LIBRARY_DEPENDS)
